Ruby - Feature #19616

Remove ext/readline from Ruby 3.3
04/25/2023 08:01 AM - hsbt (Hiroshi SHIBATA)

Status: Closed
Priority: Normal
Assignee:

Target version:

Description

We still bundled ext/readline that is GNU Readline wrapper. But we already have reline written by pure Ruby. It's time to remove it
from Ruby releases.

Motivation:

e We can skip to install readline or libedit for testing ruby language.
¢ | hope to reduce external dependencies from the perspective of ruby-build maintainer.

If users hope to use ext/readline, they can install it with gem install readline-ext.

History

#1 - 04/25/2023 12:38 PM - Eregon (Benoit Daloze)

| suspect a fair amount of code still uses Readline.readline.
Would it make sense if we had a readline.rb which is just require "reline"; Readline = Reline?
Then also we would no longer need to maintain https:/github.com/ruby/readline-ext anymore.

A big part of my concern here is other Ruby implementations like JRuby and TruffleRuby have their own implementations of Readline (using JLine).
It would be great if we can drop them rather than keep maintaining them, but we can only do so if the readline-ext gem is not used much in practice.
Hence if readline-ext would just reuse reline, then we can truly drop the dependency on libreadline and don't need to maintain code linking to it at all
anymore (neither the C extension and neither Readline-JLine).

#2 - 04/25/2023 12:57 PM - hsbt (Hiroshi SHIBATA)
- Tracker changed from Bug to Feature

- Backport deleted (3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN)

#3 - 04/25/2023 12:59 PM - hsbt (Hiroshi SHIBATA)

Would it make sense if we had a readline.rb which is just require "reline"; Readline = Reline?

We already have it: https:/github.com/ruby/readline/blob/master/lib/readline.rb

#4 - 04/25/2023 05:19 PM - Eregon (Benoit Daloze)
Oh this is great, | missed it.
+1 from me.

#5 - 05/02/2023 12:57 AM - hsbt (Hiroshi SHIBATA)
https://github.com/ruby/ruby/pull/7781

#6 - 05/09/2023 04:29 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Open to Closed

| removed ext/readline at https:/github.com/ruby/ruby/commit/59fd67fc3d405e529e038172e769ff20a8fb5535

Welcome comments for migrating to reline if you have concern.

#7 - 06/01/2023 10:02 AM - Eregon (Benoit Daloze)
I noticed Rails's Gemfile added a dependency to readline-ext in https://github.com/rails/rails/commit/a6e0b0acb2d1e85a8f90bdf956e7549bcad46896

06/14/2025 12



https://github.com/ruby/readline-ext
https://github.com/ruby/readline/blob/master/lib/readline.rb
https://github.com/ruby/ruby/pull/7781
https://github.com/ruby/ruby/commit/59fd67fc3d405e529e038172e769ff20a8fb5535
https://github.com/rails/rails/commit/a6e0b0acb2d1e85a8f90bdf956e7549bcad46896

due to some incompatibility.
| filed https://github.com/ruby/reline/issues/546 to hopefully resolve that incompatibility.
